#include <sys/mman.h>

#include <err.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

void usage(void);

int
main(int argc, char *argv[])
{

	argc--;
	argv++;

	if (argc == 0)
		usage();

	if (madvise(0, 0, MADV_PROTECT) != 0)
		warn("madvise failed");

	errno = 0;
	execvp(*argv, argv);
	err(errno == ENOENT ? 127 : 126, "%s", *argv);
}

void
usage(void)
{

	(void)fprintf(stderr,
	    "usage: mprotect utility [argument ...]\n");
	exit(1);
}